# -*- coding: utf-8 -*-
""" renvoit l'affichage d'une action """
from twisted.python import log
from nevow import loaders, tags as T, static, rend, inevow
from nevow.url import URL

import socket
from ead2.frontend.web.config import ENCODING
from ead2.frontend.web.lib import json
from ead2.frontend.web.gabarit import format_action
from ead2.frontend.web.config import ACTION_SOCKET_TIMEOUT

class Action(rend.Page):
    """ gere les actions :
        :action_name: nom de l'action 
        :menu: menu de description des actions disponibles
    """
    docFactory = loaders.xmlstr('''
            <div xmlns:nevow="http://nevow.com/ns/nevow/0.1">
                       <span nevow:render='action'/>
                       </div>
                      
                       ''')
                                                  
    def __init__(self, action_name, menu, ctx):
        self.ctx = ctx
        self.action = action_name
        self.actions = menu["actions"]
        self.menu = menu["menu"]
        self.description = self.actions[self.action][0].encode(ENCODING)
        self.params = self.actions[self.action][1]
    
    def render_action(self, ctx, data):
        """ rend le formulaire pour une action """
        session = inevow.ISession(self.ctx)
        request = inevow.IRequest(self.ctx)
        url = URL.fromContext(self.ctx)
        key = None
        # si on revient d'un formulaire on evalue les donnees ecrites en Json
        if 'JSONstr' in request.args.keys():
            try:
                #result = eval(request.args['JSONstr'][0])# eval du retour javascript
                result = json.read(request.args['JSONstr'][0])
                key = result.keys()[0]
                return_res = result[key]
                request.args.pop('JSONstr')
            except:
                log.err( "Erreur de structure du param de type JSON dans la requete")
        # pour tout plugin on renvoit et les args de la requete afin qu il gere sa propre url
        params = {'request':request.args}
        # si on a des parametres JSON dans la requete on les renvoient
        if key is not None:
            params.update({key:return_res})
        magic_nb = session.magic_number
        socket.setdefaulttimeout(ACTION_SOCKET_TIMEOUT)
        #log.msg("Les valeurs envoyée au backend %s"%params)
        return_code, data = session.ead_server.execute_action(unicode(self.action), params, magic_nb)
        if return_code == 0:
            return format_action(data, session.ead_server, magic_nb)
