# -*- coding: utf-8 -*-
""" diode d'état """
from nevow import loaders, tags as T, rend

class Diode(rend.Fragment):
    docFactory = loaders.xmlstr('''\
                            <div xmlns:nevow="http://nevow.com/ns/nevow/0.1" >                             
                                     <span nevow:render="diode"/>
                                </div>
                                ''')
    def __init__(self, description, status):
        """ :description: intitule de l'etat affiche 
            :status: statut a presenter True/False
        """
        self.description = description
        if status:
            self.status = 'on'
        else:
            self.status = 'off'

    def render_diode(self, ctx, data):
        """ rend la diode d'état """
        tag = T.div(_class='diode')[T.div(render=T.directive('descr')), T.div(render=T.directive('led'))]
        return tag
    
    def render_descr(self, ctx, data):
        """ rend la description """
        return T.p[self.description]
    
    def render_led(self, ctx, data):
        """ rend le voyant """
        return T.img(src='/image/diode_%s.png'%self.status)
